![React Table Header](https://github.com/tannerlinsley/react-table/raw/master/media/header.png)

<img src='https://github.com/tannerlinsley/react-table/raw/master/media/logo.png' width='300'/>

Hooks for building **lightweight, fast and extendable datagrids** for React

<a href="https://twitter.com/intent/tweet?button_hashtag=TanStack" target="\_parent">
  <img alt="#TanStack" src="https://img.shields.io/twitter/url?color=%2308a0e9&label=%23TanStack&style=social&url=https%3A%2F%2Ftwitter.com%2Fintent%2Ftweet%3Fbutton_hashtag%3DTanStack" />
</a><a href="https://github.com/tannerlinsley/react-table/actions?table=workflow%3A%22react-table+tests%22">
<img src="https://github.com/tannerlinsley/react-table/workflows/react-table%20tests/badge.svg" />
</a><a href="https://npmjs.com/package/react-table" target="\_parent">
  <img alt="" src="https://img.shields.io/npm/dm/react-table.svg" />
</a><a href="https://bundlephobia.com/result?p=react-table@latest" target="\_parent">
  <img alt="" src="https://badgen.net/bundlephobia/minzip/react-table@latest" />
</a><a href="#badge">
    <img alt="semantic-release" src="https://img.shields.io/badge/%20%20%F0%9F%93%A6%F0%9F%9A%80-semantic--release-e10079.svg">
  </a><a href="https://github.com/tannerlinsley/react-table/discussions">
  <img alt="Join the discussion on Github" src="https://img.shields.io/badge/Github%20Discussions%20%26%20Support-Chat%20now!-blue" />
</a><a href="https://github.com/tannerlinsley/react-table" target="\_parent">
  <img alt="" src="https://img.shields.io/github/stars/tannerlinsley/react-table.svg?style=social&label=Star" />
</a><a href="https://twitter.com/tannerlinsley" target="\_parent">
  <img alt="" src="https://img.shields.io/twitter/follow/tannerlinsley.svg?style=social&label=Follow" />
</a>

Enjoy this library? Try them all! [React Query](https://github.com/tannerlinsley/react-query), [React Form](https://github.com/tannerlinsley/react-form), [React Charts](https://github.com/tannerlinsley/react-charts)

### [Become a Sponsor](https://github.com/sponsors/tannerlinsley/)

## Features

- Lightweight (5kb - 14kb+ depending on features used and tree-shaking)
- Headless (100% customizable, Bring-your-own-UI)
- Auto out of the box, fully controllable API
- Sorting (Multi and Stable)
- Filters
- Pivoting & Aggregation
- Row Selection
- Row Expansion
- Column Ordering
- Animatable
- Virtualizable
- Resizable
- Server-side/controlled data/state
- Extensible via hook-based plugin system

## Used By

- [Intuit](https://intuit.com)
- [Google](https://google.com)
- [Amazon](https://amazon.com)
- [Apple](https://apple.com)
- [AutoZone](https://autozone.com)
- [Microsoft](https://microsoft.com)
- [Cisco](https://cisco.com)
- [Uber](https://uber.com)
- [Salesforce](http://salesforce.com/)
- [Walmart](https://walmart.com)
- [Wix](https://wix.com)
- [HP](https://hp.com)
- [Docusign](https://docusign.com)
- [Tripwire](https://tripwire.com)
- [Yahoo!](https://yahoo.com)
- [Ocado](https://ocado.com)
- [Nordstrom](https://nordstrom.com)
- [TicketMaster](https://ticketmaster.com)
- [Comcast Business](https://business.comcast.com)

> _These analytics are made available via the awesome [Scarf](https://www.npmjs.com/package/@scarf/scarf) package analytics library_

## Github Sponsors

This library is being built and maintained by me, @tannerlinsley and I am always in need of more support to keep this project afloat. If you would like to get additional support, add your logo or name on this README, or simply just contribute to my open source Sponsorship goal, [visit my Github Sponsors page!](https://github.com/sponsors/tannerlinsley/)

[![Diamond Sponsors](https://raw.githubusercontent.com/tannerlinsley/files/master/sponsorships/diamond.png)](https://github.com/sponsors/tannerlinsley)

<table>
  <tbody>
    <tr>
      <td>
        <a href="https://github.com/sponsors/tannerlinsley" target="_blank">
          Get Your Logo Here!
        </a>
      </td>
    </tr>
  </tbody>
</table>

[![Gold Sponsors](https://raw.githubusercontent.com/tannerlinsley/files/master/sponsorships/gold.png)](https://github.com/sponsors/tannerlinsley)

<table>
  <tbody>
    <tr>
      <td>
        <a href="https://tryretool.com/?utm_source=sponsor&utm_campaign=react_table" target="_blank">
          <img width='350' src="https://raw.githubusercontent.com/tannerlinsley/files/master/images/patreon/sponsor-retool.png" />
        </a>
      </td>
    </tr>
  </tbody>
</table>

[![Silver Sponsors](https://raw.githubusercontent.com/tannerlinsley/files/master/sponsorships/silver.png)](https://github.com/sponsors/tannerlinsley)

<table>
  <tbody>
    <tr>
      <td>
        <a href="https://neo4j.com/" target="_blank">
          <img width='225' src="https://go.neo4j.com/rs/710-RRC-335/images/neo4j_logo.svg" alt="Nozzle - Google Keyword Rank Tracker" />
        </a>
      </td>
      <td>
        <a href="https://nozzle.io" target="_blank">
          <img width='225' src="https://nozzle.io/img/logo-blue.png" alt="Nozzle - Google Keyword Rank Tracker" />
        </a>
      </td>
    </tr>
  </tbody>
</table>

[![Bronze Sponsors](https://raw.githubusercontent.com/tannerlinsley/files/master/sponsorships/bronze.png)](https://github.com/sponsors/tannerlinsley)

<table>
  <tbody>
    <tr>
      <td>
        <a href="https://tripwire.com" target="_blank">
          <img width='130' src="https://www.tripwire.com/-/media/tripwiredotcom/icons/tripwire-logo-footer.svg" />
        </a>
      </td>
      <td>
        <a href="https://www.fream.pl/" target="_blank">
          <img width='130' src="https://www.fream.pl/wp-content/uploads/2017/08/logo.png" />
        </a>
      </td>
      <td>
        <a href="https://www.encamp.com/careers/senior-software-engineer" target="_blank">
          <img width='130' src="https://assets.website-files.com/5dee7e4754c6bbc1eaf4210b/5deea3042cdb07ff7082211d_encamp-logo.svg" />
        </a>
      </td>
    </tr>
  </tbody>
</table>

[![Supporters](https://raw.githubusercontent.com/tannerlinsley/files/master/sponsorships/supporters.png)](https://github.com/sponsors/tannerlinsley)

- Jon Eickmeier
- [Richard Hefner (@rhefner)](https://github.com/rhefner)
- [Steeve Lennmark (@snorkypie)]("https://gitHub.com/snorkypie)
- [Sam Mason de Caires (@samjbmason)](https://gitHub.com/samjbmason)

[![Fans](https://raw.githubusercontent.com/tannerlinsley/files/master/sponsorships/fans.png)](https://github.com/sponsors/tannerlinsley)

- Hugo Meissner
- Benoit Leger-Derville
- Thomas Funk
- David Pickut
- Jordan Soltman
- Robert Tajnšek
- Eric Lanehart (@pushred)
- Anish P Patel (@anishpatelyaadada)
- Janus Reith (@janus-reith)
- Timo Mämecke (@timomeh)
- Tyler Reiff (@reiff12)
- Matt Stvartak (@mattstvartak)
- JP Rosevear (@jprosevear)
- Stefan Khan-Kernahan (@skhanker)
- Jesse Jafa (@awareness481)
- Salik Syed (@saliksyed)
- Ujjwal Pachori (@UjjwalP2)
- Chet Corcos (@ccorcos)
- Yefri Laura (@yefrioscar)
- Muhammad Umar (@umarmuha)
- Joe Alden (@joalden)
- Standard Resume (@StandardResumeSponsors)
- Jay (@jjstrat3)

### [Become a Sponsor](https://github.com/sponsors/tannerlinsley/)

## Documentation

- [Installation](./docs/installation.md) - Walk through how to install React Table
- [Concepts](./docs/concepts.md) - Read how React Table works and how you can use it better
- [Examples](./docs/examples.md) - Experience and learn from some examples and guides of how to use React Table and implement common patterns
- [API](./docs/api/README.md) - Get to know React Table's API
- [FAQ](./docs/faq.md) - Learn how to use React Table for specific challenges and tasks
- [Previous Versions](#previous-versions)
- [Contributing](./CONTRIBUTING.md) - Become familiar with how to contribute back to React Table
- [Code of Conduct](./CODE_OF_CONDUCT.md) - Be a good React Table citizen by following these repository rules

## Product Examples

The examples below are built by our partners from [Creative Tim](https://creative-tim.com/?ref=react-table.js.org) and demonstrate how React Table can be integrated in real world applications. There are many examples that you can play with and each premium product comes with a free & open source version, too!

<table>
  <tbody>
    <tr>
      <td>
        <a href='https://www.creative-tim.com/product/material-dashboard-pro-react?ref=react-table.js.org'>
          <div>Material Dashboard PRO React</div>
          <img src="https://s3.amazonaws.com/creativetim_bucket/products/80/original/opt_mdp_react_thumbnail.jpg?1522160852" />
        </a>
        <div><small>Premium: $59 - Lite: Free</small></div>
      </td>
      <td>
        <a href='https://www.creative-tim.com/product/black-dashboard-pro-react?ref=react-table.js.org'>
          <div>Black Dashboard PRO React</div>
          <img src="https://s3.amazonaws.com/creativetim_bucket/products/138/original/opt_bdp_thumbnail.jpg?1547454513" />
        </a>
        <div><small>Premium: $59 - Lite: Free</small></div>
      </td>
      <td>
        <a href='https://www.creative-tim.com/product/now-ui-dashboard-pro-react?ref=react-table.js.org'>
          <div>Now UI Dashboard PRO React</div>
          <img src="https://s3.amazonaws.com/creativetim_bucket/products/73/original/opt_nudp_react_thumbnail.jpg?1518533306" />
        </a>
        <div><small>Premium: $59 - Lite: Free</small></div>
      </td>
    </tr>
  </tbody>
</table>

## Previous Versions

### Version 6

v6 is a great library and while it is still available to install and use, I am no longer offering any long-term support for it. If you intend to keep using v6, I recommend maintaining your own fork of the library and keeping it up to date for your version of React.

#### Where are the docs for the older v6 version?

Please [visit the v6 branch](https://github.com/tannerlinsley/react-table/tree/v6)

#### I want to migrate from v6 to v7. How do I do that?

The differences between the 2 versions are incredibly massive. Unfortunately, I cannot write a one-to-one upgrade guide for any of v6's API, simply because much of it is irrelevant with v7's headless approach. The best approach for migrating to v7 is to learn its API by reading the documentation and then following some of the examples to begin building your own table component.

In case you would need to have both v6 and v7 in one app during the migration process (large codebase, complex use cases), you can either (1) fork and maintain your own local version of React Table v6 or (2) install the [`react-table-6` alias package](https://www.npmjs.com/package/react-table-6) for use alongside the `react-table` package.
